import { csv, select } from 'd3';
import { scatterPlot } from './scatterPlot';

// Function to fetch data from the URI
const csvUrl = 'https://gist.githubusercontent.com/Ramch16/057790908ed8a17561a4a4138f431e85/raw/f03e45bee14fc861f1cb9761200120440ddd4ee0/Iris_ICE7.csv'
const parseRow = (d) => {
  d.SepalLengthCm = +d.SepalLengthCm;
  d.SepalWidthCm = +d.SepalWidthCm;
  d.PetalLengthCm = +d.PetalLengthCm;
  d.PetalWidthCm = +d.PetalWidthCm;
  return d;
};

const width = window.innerWidth;
const height = window.innerHeight;
const svg = select('body')
  .append('svg')
  .attr('width', width)
  .attr('height', height);

const main = async () => {
  svg.call(
    scatterPlot()
      .width(width)
      .height(height)
      .data(await csv(csvUrl, parseRow))
      .xValue((d) => d.PetalWidthCm)
      .yValue((d) => d.SepalLengthCm)
      .symbolValue((d) => d.Species)
      .margin({
        top: 20,
        right: 20,
        bottom: 80,
        left: 120,
      })
      .size(100)
  );
  
  // displaying the x, y, axis and chart lables 
   svg.append('text')
      .attr('class','axis-label')
      .attr('x',innerWidth/2.0)
      .attr('y',50)
      .style('font-size', '30px')
      .text("Scatter Plot")

      svg.append('text')
      .attr('class', 'axis-label')
      .attr('x', width / 2)
      .attr('y', height - 10)
      .style('font-size', '20px')
      .style('text-anchor', 'middle')
      .text('Petal_Width ');

  svg.append('text')
      .attr('class', 'axis-label')
      .style('font-size', '20px')
      .style('text-anchor', 'middle')
      .attr('y', 50)
      .attr('x',-240)
      .text('Sepal_Length')
      .attr("transform", "rotate(-90)");
};
main();
