// importing d3 sources
import {
  scaleLinear,scaleOrdinal,extent, axisLeft,axisBottom,symbols,symbol,
} from 'd3';

// exporting definations to scatterplot javascript 
export const scatterPlot = () => {
  let xValue;let yValue;let width;
  let height; let data;
  let symbolValue; let margin;
  let size;

  const my = (selection) => {
// X axis scale line
    const x = scaleLinear()
      .domain(extent(data, xValue))
      .range([margin.left, width - margin.right]);
// Y axis scale line
    const y = scaleLinear()
      .domain(extent(data, yValue))
      .range([height - margin.bottom, margin.top]);
// defining symbles of dataset
    const symbolScale = scaleOrdinal()
      .domain(data.map(symbolValue))
      .range(symbols);
    const symbolGenerator = symbol().size(size);
// Define the layout for the plot
    const marks = data.map((d) => ({
      x: x(xValue(d)),
      y: y(yValue(d)),
      pathD: symbolGenerator.type(symbolScale(symbolValue(d)))()
    }));

    selection
      .selectAll('path')
      .data(marks)
      .join('path')
      .attr('d', (d) => d.pathD)
      .attr('transform', (d) => `translate(${d.x},${d.y})`)
      .attr('fill', (d) => d.color='brown');

    selection
      .append('g')
      .attr('transform', `translate(${margin.left})`)
      .call(axisLeft(y));

    selection
      .append('g')
      .attr(
        'transform',
        `translate(0,${height - margin.bottom})`
      )
      .call(axisBottom(x));
  };
// calling defined functions 
  my.width = function (_) {
    return arguments.length ? ((width = +_), my) : width;
  };

  my.height = function (_) {
    return arguments.length ? ((height = +_), my) : height;
  };

  my.data = function (_) {
    return arguments.length ? ((data = _), my) : data;
  };

  my.xValue = function (_) {
    return arguments.length ? ((xValue = _), my) : xValue;
  };

  my.yValue = function (_) {
    return arguments.length ? ((yValue = _), my) : yValue;
  };

  my.symbolValue = function (_) {
    return arguments.length? ((symbolValue = _), my): symbolValue;
  };

  my.margin = function (_) {
    return arguments.length ? ((margin = _), my) : margin;
  };

  my.size = function (_) {
    return arguments.length ? ((size = +_), my) : size;
  };

  return my;
};
